import numpy as np
import cv2
drawing = False
x0, y0 = 0,0
x1, y1 = 1, 1
m1, m2 = 0, 0

def img_thresh(img1, img2, m1, m2, kernel):
    ret, thresh1 = cv2.threshold(img1, m1, m2, cv2.THRESH_BINARY)
    ret, thresh2 = cv2.threshold(img2, m1, m2, cv2.THRESH_BINARY)
    thr = cv2.morphologyEx(thresh1-thresh2, cv2.MORPH_OPEN, kernel)
    return thr


def comput_img(image):
    image = cv2.cvtColor(image, cv2.COLOR_BGR2GRAY)
    ret, image = cv2.threshold(image, 200, 255, cv2.THRESH_BINARY)
    contours,hierarchy = cv2.findContours(image, 1, 2)
    if contours != []:
        cnt = contours[0]
        x,y,w,h = cv2.boundingRect(cnt)
        print "width is: "+str(w)
        print "heigt is: "+str(h)
    else:
        print "width is: 0"
        print "heigt is: 0"


def set_m1(x1):
    global m1, img, thr
    m1 = x1
    thr = img_thresh(image_93, image_13, m1, m2, kernel)
    img = cv2.cvtColor(thr, cv2.COLOR_GRAY2BGR)
    
def set_m2(x2):
    global m2, img, thr
    m2 = x2
    thr = img_thresh(image_93, image_13, m1, m2, kernel)
    img = cv2.cvtColor(thr, cv2.COLOR_GRAY2BGR)

def draw_rec(event, x, y, flags, param):
    global x0, y0, drawing, img, cut_img
    if event == cv2.EVENT_LBUTTONDOWN:
        drawing = True
        x0, y0 = x, y

    elif event == cv2.EVENT_MOUSEMOVE and flags == cv2.EVENT_FLAG_LBUTTON:
        if drawing == True:
            x1, y1 = x, y
            img = cv2.cvtColor(thr, cv2.COLOR_GRAY2BGR)
            cv2.rectangle(img, (x0, y0), (x1, y1), (0, 255, 0), 1)

    elif event == cv2.EVENT_LBUTTONUP:
        drawing == False
        x1, y1 = x, y
        img = cv2.cvtColor(thr, cv2.COLOR_GRAY2BGR)
        cv2.rectangle(img, (x0, y0), (x1, y1), (0, 255, 0), 1)
        if x0>x1:
            x0, x1 = x1, x0
        if y0>y1:
            y0, y1 = y1, y0
        cut_img = img[y0+1:y1, x0+1:x1, :]
        cv2.imshow("image_cut", img_background)


#cv2.namedWindow("image93")
image_93 = cv2.imread("93.png",0)

#cv2.namedWindow("image13")
image_13 = cv2.imread("13.png",0)
img_background = np.ones((150, 150), np.uint8)*255

cv2.namedWindow("image")
cv2.createTrackbar("min", "image", 0, 255, set_m1)
cv2.createTrackbar("max", "image", 0, 255, set_m2)
kernel = np.ones((5,5), np.uint8)
cv2.setMouseCallback("image", draw_rec)

thr = img_thresh(image_93, image_13, m1, m2, kernel)
img = cv2.cvtColor(thr, cv2.COLOR_GRAY2BGR)
cut_img = img[y0+1:y1, x0+1:x1, :]
cv2.imshow("image_cut", img_background)
while(True):
    height, width = cut_img.shape[:2]
    cv2.imshow("image", img)
    if height>0 and width>0:
        cv2.imshow("image_cut", cut_img)
    k = cv2.waitKey(1)&0xFF

    if k==13:
        comput_img(cut_img)
    
    if k==27:
        break
cv2.destroyAllWindows()
